/*
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License");  you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 *
 * The Original Code is Protege-2000.
 *
 * The Initial Developer of the Original Code is Stanford University. Portions
 * created by Stanford University are Copyright (C) 2001.  All Rights Reserved.
 *
 * Protege-2000 was developed by Stanford Medical Informatics
 * (http://www.smi.stanford.edu) at the Stanford University School of Medicine
 * with support from the National Library of Medicine, the National Science
 * Foundation, and the Defense Advanced Research Projects Agency.  Current
 * information about Protege can be obtained at http://protege.stanford.edu
 *
 * This code developed by The Department of Biomedical and Health Informatics at 
 * at the University of Washington (http://www.bhi.washington.edu)
 *
 */
     
package edu.washington.bhi.protegex.storage.xml;


import java.util.*;

     
public class XMLBase {
     
     public void XMLBase() {
     }
     
    protected String unNormalize(String s){
	StringBuffer str = new StringBuffer();

        int len = (s != null) ? s.length() : 0;
        for ( int i = 0; i < len; i++ ) {
            char ch = s.charAt(i);
            switch ( ch ) {
//	    case '_': {
//		// during normalizing, space was replaced with "_",
//		// and "_" was replaced with "&_"
//		str.append(" ");
//		break;
//	    }
            case '&': {
		String temp = s.substring(i + 1);
		if(temp.startsWith("_")){
		    str.append("_");
		    i++;
		}
		else if(temp.startsWith("lt")){
		    str.append("<");
		    i += 2;
		}
		else if(temp.startsWith("gt")){
		    str.append(">");
		    i += 2;
		}
		else if(temp.startsWith("amp")){
		    str.append("&");
		    i += 3;
		}
		else if(temp.startsWith("quot")){
		    str.append("\"");
		    i += 4;
		}
		else if(temp.startsWith("apos")){
		    str.append("\'");
		    i += 4;
		}
	    }
            default: {
                    str.append(ch);
                }
            }
        }

        return(str.toString());
    }

    /** Normalizes the given string. */
    protected String normalize(String s) {
        StringBuffer str = new StringBuffer();

        int len = (s != null) ? s.length() : 0;
        for ( int i = 0; i < len; i++ ) {
            char ch = s.charAt(i);
            switch ( ch ) {
//	    case ' ': {
//		str.append("_");
//		break;
//	    }
            case '<': {
                    str.append("&lt;");
                    break;
                }
            case '>': {
                    str.append("&gt;");
                    break;
                }
            case '&': {
                    str.append("&amp;");
                    break;
                }
            case '"': {
                    str.append("&quot;");
                    break;
                }
            case '\'': {
                    str.append("&apos;");
                    break;
                }
//	    case ':':{
//		// discard leading ":"
//		if(i > 0)
//		    str.append(ch);
//		break;
//	    }
            default: {
                    str.append(ch);
                }
            }
        }

        return(str.toString());

    } // normalize(String):String
    
    protected Collection sort(Collection col){
		if(col == null)
		    return null;
		Object objects[] = col.toArray();
		Arrays.sort(objects);
		int size = objects.length;
		Vector vec = new Vector();
		for(int i = 0; i < size; i++)
		    vec.add(objects[i]);
		return vec;
    }
    
	private static final String VARIABLE = "?VARIABLE";

    protected Float toFloat(String s) {
        Float f = null;
        try {
            if (!s.equals(VARIABLE)) {
                f = new Float(s);
            }
        } catch (Exception e) {
            printErrorMessage("Invalid floating point number: " + s);
            f = null;
        }
        return f;
    }
    
    protected void printErrorMessage(String error) {
    	System.out.println(error);
    }
    
    protected void popupErrorMessage(String error) {
    	System.out.println(error);
    }
}


